﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Bulldozer
{
    public class EntityBulldozer
    {
        /// <summary>
        /// Скорость
        /// </summary>
        public int Speed { get; private set; }
        /// <summary>
        /// Вес
        /// </summary>
        public double Weight { get; private set; }
        /// <summary>
        /// Основной цвет
        /// </summary>
        public Color BulldozerColor { get; private set; }
        /// <summary>
        /// Дополнительный цвет (для опциональных элементов)
        /// </summary>
        public Color CabinColor { get; private set; }
        public Color CovshColor { get; private set; }
        /// <summary>
        /// Признак (опция) наличия переднего ковша
        /// </summary>
        public bool HasMoldboardfront { get; private set; }
        /// <summary>
        /// Признак (опция) наличия заднего ковша
        /// </summary>
        public bool HasRipper { get; private set; }
        /// <summary>
        /// Шаг перемещения автомобиля
        /// </summary>
        public double Step => (double)Speed * 100 / Weight;
        /// <summary>
        /// Инициализация полей объекта-класса спортивного автомобиля
        /// </summary>
        /// <param name="speed">Скорость</param>
        /// <param name="weight">Вес автомобиля</param>
        /// <param name="bulldozerColor">Основной цвет</param>
        /// <param name="cabinColor">Дополнительный цвет</param>
        /// <param name="covshColor">Цвет для ковша</param>
        /// <param name="hasMoldboardfront">Признак наличия переднего ковша</param>
        /// <param name="hasRipper">Признак наличия заднего ковша</param>
        public void Init(int speed, double weight, Color bulldozerColor, Color cabinColor, Color covshColor, bool hasMoldboardfront, bool hasRipper)
        {
            Speed = speed;
            Weight = weight;
            BulldozerColor = bulldozerColor;
            CabinColor = cabinColor;
            CovshColor = covshColor;
            HasMoldboardfront = hasMoldboardfront;
            HasRipper = hasRipper;
        }
    }
}
