using System.Windows.Forms;

namespace Bulldozer
{
    public partial class FormBulldozer : Form
    {
        private DrawningBulldozer? _drawningBulldozer;
        public FormBulldozer()
        {
            InitializeComponent();
        }
        private void Draw()
        {
            if (_drawningBulldozer == null)
            {
                return;
            }
            Bitmap bmp = new(pictureBoxBulldozer.Width,
            pictureBoxBulldozer.Height);
            Graphics gr = Graphics.FromImage(bmp);
            _drawningBulldozer.DrawTransport(gr);
            pictureBoxBulldozer.Image = bmp;
        }
        private void ButtonMove_Click(object sender, EventArgs e)
        {
            if (_drawningBulldozer == null)
            {
                return;
            }
            string name = ((Button)sender)?.Name ?? string.Empty;
            switch (name)
            {
                case "buttonUp":
                    _drawningBulldozer.MoveTransport(DirectionTypeBulldozer.Up);
                    break;
                case "buttonDown":
                    _drawningBulldozer.MoveTransport(DirectionTypeBulldozer.Down);
                    break;
                case "buttonLeft":
                    _drawningBulldozer.MoveTransport(DirectionTypeBulldozer.Left);
                    break;
                case "buttonRight":
                    _drawningBulldozer.MoveTransport(DirectionTypeBulldozer.Right);
                    break;
            }
            Draw();
        }

        private void ButtonCreateBulldozer_Click(object sender, EventArgs e)
        {
            Random random = new();
            _drawningBulldozer = new DrawningBulldozer();
            _drawningBulldozer.Init(random.Next(100, 300),
            random.Next(1000, 3000),
            Color.FromArgb(random.Next(0, 256), random.Next(0, 256), random.Next(0, 256)),
            Color.FromArgb(random.Next(0, 256), random.Next(0, 256), random.Next(0, 256)),
            Color.FromArgb(random.Next(0, 256), random.Next(0, 256), random.Next(0, 256)),
            Convert.ToBoolean(random.Next(0, 2)), Convert.ToBoolean(random.Next(0, 2)), pictureBoxBulldozer.Width, pictureBoxBulldozer.Height);
            _drawningBulldozer.SetPosition(random.Next(10, 100), random.Next(10, 100));
            Draw();
        }
    }
}